//DeweyAttractor Color
color deweyCol = color(204,51,0);
      
class DeweyAttractor 
{
  Vector3D loc;
  color col;
  DeweyDict deweyDict;
  
  // constructor
  DeweyAttractor(Vector3D l, color c, DeweyDict d) 
  {
    loc = l;
    col = c;
    deweyDict = d;
  }
  
  public DeweyDict getDeweyDict()
  {
    return deweyDict;
  }
  
  void render() 
  {  
    strokeWeight(lineweight*1.75);
    stroke(col);
    point(loc.x,loc.y,loc.z);
    // compute the mouse distance with the point
    float mouseObjectDistance = sq(mouseX-screenX(loc.x,loc.y,loc.z))+sq(mouseY-screenY(loc.x,loc.y,loc.z));
    // if the distance is smaller than a certain value
    if(mouseObjectDistance <20)
      {
        // add a bigger point
        strokeWeight(lineweight*5);
        point(loc.x,loc.y,loc.z);
        fill(col);
        // add text label
        textMode(SHAPE);
        // if the distance is close, make the textsize smaller
        if(cam.getDistance()<100){textSize(8);}
        // if the distance is far, make the textsize bigger
        else{textSize(12);}
        text(this.getDeweyDict().name,loc.x+2,loc.y+1.5,loc.z);
      }
  } 
}
