//GUI
color bcolor = color(220,220,220);
color fcolor = color(128,128,128);
float lineweight = 2f;

float speed = 0.1f;

int boidNumber = 1000;
float searchDistance = 60;
float gridSize = 50;

float deweyAttractForce = 0.5f;
float separationForce = 2.0;
float alignmentForce = 1.5;
float cohesionForce = 1.5;
float randomForce = 0.2;

boolean pause = false;
boolean drawNeighborConnection = false;
boolean drawDeweyConnection = true;


void setGui(){
  // Set up the fonts
  PFont pfont = createFont("Arial", 16,true);
  ControlFont font = new ControlFont(pfont, 12);
  float X = 50;
  float distance =30;
  int index = 1;
  
  // draw the GUI
  cp5.addSlider("gridSize")
  .setColorLabel(color(0,0,0))
  .setRange(10, 100)
  .setPosition(X, distance*index)
  .setFont(font)
  .setSize(100,15)
  .setColorValue(color(0,0,0))
    .setColorForeground(fcolor)
    .setColorBackground(bcolor);
    
  index++;  
  cp5.addSlider("lineweight")
  .setColorLabel(color(0,0,0))
  .setRange(1, 5)
  .setPosition(X, distance*index)
  .setFont(font)
  .setSize(100,15)
  .setColorValue(color(0,0,0))
    .setColorForeground(fcolor)
    .setColorBackground(bcolor);
    
  index++; 
  cp5.addSlider("speed")
  .setColorLabel(color(0,0,0))
  .setRange(0, 20)
  .setPosition(X, distance*index)
  .setFont(font)
  .setSize(100,15)
  .setColorValue(color(0,0,0))
    .setColorForeground(fcolor)
    .setColorBackground(bcolor);
  
  index++;  
  cp5.addSlider("deweyAttractForce")
  .setColorLabel(color(0,0,0))
  .setRange(0, 10)
  .setPosition(X, distance*index)
  .setFont(font)
  .setSize(100,15)
  .setColorValue(color(0,0,0))
    .setColorForeground(fcolor)
    .setColorBackground(bcolor);
  
  index++;  
  cp5.addToggle("pause")
  .setColorLabel(color(0,0,0))
  .setPosition(X, distance*index)
  .setFont(font)
  .setSize(25,15)
  .setColorValue(color(0,0,0))
    .setColorForeground(fcolor)
    .setColorBackground(bcolor);
    
  index++;  
  cp5.addToggle("drawNeighborConnection")
  .setColorLabel(color(0,0,0))
  .setPosition(X, distance*index)
  .setFont(font)
  .setSize(25,15)
  .setColorValue(color(0,0,0))
    .setColorForeground(fcolor)
    .setColorBackground(bcolor);

  index++;  
  cp5.addToggle("drawDeweyConnection")
  .setColorLabel(color(0,0,0))
  .setPosition(X, distance*index)
  .setFont(font)
  .setSize(25,15)
  .setColorValue(color(0,0,0))
    .setColorForeground(fcolor)
    .setColorBackground(bcolor);
  
  cp5.setAutoDraw(false);
}

// A function for draw GUI correctly
void gui(){
  hint(DISABLE_DEPTH_TEST);
  cam.beginHUD();
  cp5.draw();
  cam.endHUD();
  hint(ENABLE_DEPTH_TEST);
  
  // Deactivate the camera when the mouse is within the GUI area
  if((mouseX<360)&(mouseY<240)) {cam.setActive(false);}
  else{cam.setActive(true);}
}
